// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_internal_BinderSocket_hpp
#define anna_comm_internal_BinderSocket_hpp

#include <anna/comm/ClientSocket.hpp>

namespace anna {

namespace comm {

namespace handler {
class BinderSocket;
}

class ServerSocket;

//-------------------------------------------------------------------------------
// Socket para conectar con un bind compartido.
//-------------------------------------------------------------------------------
class BinderSocket : public ClientSocket {
public:
  static const char* className() throw() { return "anna::comm::BinderSocket"; }

private:
  ServerSocket& a_serverSocket;

  // socket Socket que esta intentando hacer el bind sobre una IP:puerto compartido.
  BinderSocket(ServerSocket*);
  void requestBind(const struct sockaddr* s, const int len) throw(RuntimeException);
  void responseBind() throw(RuntimeException);
  void waitBind(const Millisecond &maxDelay) throw(RuntimeException);


  friend class ServerSocket;
  friend class handler::BinderSocket;
};

}
}

#endif



