// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_codec_MessagesDeque_hpp
#define anna_diameter_codec_MessagesDeque_hpp

// Standard
#include <deque>
#include <map>
#include <string>

namespace anna {
namespace diameter {
namespace codec {


class Message;


class MessagesDeque {

typedef std::deque<anna::diameter::codec::Message*> codec_messages_deque;
typedef std::deque<anna::diameter::codec::Message*>::iterator codec_messages_deque_iterator;
typedef std::deque<anna::diameter::codec::Message*>::const_iterator codec_messages_deque_const_iterator;
typedef std::map < int /* message code */, codec_messages_deque* > messages_container;
typedef std::map < int /* message code */, codec_messages_deque* >::iterator  messages_iterator;
typedef std::map < int /* message code */, codec_messages_deque* >::const_iterator  messages_const_iterator;

  messages_container a_deques;
  bool a_rotate;

  public:
    MessagesDeque() { a_rotate = false; }
    ~MessagesDeque() { clear(); }

    bool rotate() const throw() { return a_rotate; }
    void rotate(bool r) throw() { a_rotate = r; }

    void clear () throw();
    void dump (const char *filenamePrefix = "programmed_message") throw();
    void addMessage(int code, anna::diameter::codec::Message *message) throw();
    anna::diameter::codec::Message* getMessage(int code) const throw();
    void nextMessage(int code) throw();
    std::string asString(const char *queueName) const throw();
};

}
}
}


#endif

