// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_functions_hpp
#define anna_diameter_functions_hpp


// Local
#include <anna/diameter/defines.hpp>

// STL
#include <string>

//------------------------------------------------------------------------------
//---------------------------------------------------------------------- #define
//------------------------------------------------------------------------------

namespace anna {

namespace diameter {


struct functions {

//public:

  /**
  * Returns Avp identification as string:
  * <pre>
  *
  *           '(<code>,<vendorId>)'
  * </pre>
  */
  static std::string avpIdAsPairString(const AvpId & avpId) throw();


  /**
  * Returns Command identification as string:
  * <pre>
  *
  *           '(<code>,request|answer)'
  * </pre>
  */
  static std::string commandIdAsPairString(const CommandId & commandId) throw();
};


}
}


#endif

