// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_xml_Binary_hpp
#define anna_xml_Binary_hpp

#include <anna/core/RuntimeException.hpp>
#include <anna/core/util/Recycler.hpp>

namespace anna {

namespace xml {

class Binary {
protected:
  typedef unsigned int Offset;
  typedef Recycler <std::string> string_pool;

  struct Addressing { enum _v { Offset8 = 8, Offset16 = 16, Offset32 = 32 }; };
  struct ItemCode {
    enum _v {
      Node = 0xff, Attribute = 0xfe, Text = 0xfd, Namespace = 0xfc, NodeWithNamespace = 0xfb, AttributeWithNamespace = 0xfa,
      TextValue = 0xe0, IntegerValue = 0xe1, LongValue = 0xe2
    };
  };

  static const char Version = 0x10;
  static const Offset IndexVersion = 0;
  static const Offset IndexAddressing = 1;
  static const Offset IndexBodyBegin = 2;

  string_pool a_strings;

  static int sizeOf(const Addressing::_v v) throw() { return v >> 3; }
};

}
}

#endif

