// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/codec/basetypes/OctetString.hpp>

// Standard
#include <string>


//------------------------------------------------------------------------------
//----------------------------------------------------- OctetString::codeBasic()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::OctetString::codeBasic(char* buffer, int &size) throw(anna::RuntimeException) {
  memcpy(buffer, a_value.c_str(), size = getSize());
}

//------------------------------------------------------------------------------
//-------------------------------------------- OctetString::setPrintableString()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::OctetString::setPrintableString(const char * printableString) throw(anna::RuntimeException) {
  setValue(printableString);
}


//------------------------------------------------------------------------------
//----------------------------------------------- OctetString::assertPrintable()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::OctetString::assertPrintable() const throw(anna::RuntimeException) {
  /*std::string dummy =*/
  AvpData::assertPrintable(a_value.c_str(), a_value.size());
}


//------------------------------------------------------------------------------
//-------------------------------------------------------- OctetString::decode()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::OctetString::decode(const char* buffer, const int size) throw(anna::RuntimeException) {
  if(!buffer) {
    std::string msg = getFormatName(); // Unknown format inherit from OctetString
    msg += "::decode | Null Buffer provided";
    throw anna::RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  a_value.assign(buffer, size); // direct decode due to private member nature
}

